/* odmacom.h - Component Object Model related definitions, macros, etc. for
   ODMA version 1.0. */

#if !defined(ODMACOM_H)
#define ODMACOM_H

#if !defined(ODMA_H)
#include "odma.h"
#endif

// Load OLE-2 Component Object Header (if necessary)
#if !defined(_COMPOBJ_H_)
#include <memory.h>             // Required by COMPOBJ.H
#include <compobj.h>
#endif
#if !defined( _OLE2_H_ )
#include <ole2.h>
#include <moniker.h>
#endif

// Define the IODMDocMan interface
DEFINE_OLEGUID( IID_IODMDocMan, 0x22FF0, 0, 0 );

#undef  INTERFACE
#define INTERFACE   IODMDocMan

DECLARE_INTERFACE_(IODMDocMan, IUnknown)
{
 // *** IUnknown methods ***
    STDMETHOD(        QueryInterface) (THIS_ REFIID riid, LPVOID FAR *ppvObj)  PURE;
    STDMETHOD_(ULONG, AddRef)         (THIS) PURE;
    STDMETHOD_(ULONG, Release)        (THIS) PURE;

 // *** IODMAManager methods ***
    STDMETHOD_(ODMSTATUS, SelectDoc) (THIS_
				       LPSTR lpszDocId,
				       LPDWORD pdwFlags ) PURE;
    STDMETHOD_(ODMSTATUS, OpenDoc) (THIS_
				     DWORD flags,
				     LPSTR lpszDocId,
				     LPSTR lpszDocLocation ) PURE;
    STDMETHOD_(ODMSTATUS, SaveDoc) (THIS_
				     LPSTR lpszDocId,
				     LPSTR lpszNewDocId ) PURE;
    STDMETHOD_(ODMSTATUS, CloseDoc) (THIS_
				      LPSTR lpszDocId,
				      DWORD activeTime,
				      DWORD pagesPrinted,
				      LPVOID sessionData,
				      WORD dataLen ) PURE;
	STDMETHOD_(ODMSTATUS, NewDoc) (THIS_
					LPSTR lpszDocId,
					DWORD dwFlags,
					LPSTR lpszFormat,
					LPSTR lpszDocLocation  ) PURE;
	STDMETHOD_(ODMSTATUS, SaveAs) (THIS_
					LPSTR lpszDocId,
					LPSTR lpszNewDocId,
					LPSTR lpszFormat,
					ODMSAVEASCALLBACK pcbCallBack,
					LPVOID pInstanceData ) PURE;
	STDMETHOD_(ODMSTATUS, Activate) (THIS_
					WORD action,
					LPSTR lpszDocId ) PURE;
	STDMETHOD_(ODMSTATUS, GetDocInfo) (THIS_
					LPSTR lpszDocId,
					WORD item,
					LPSTR lpszData,
					WORD dataLen ) PURE;
	STDMETHOD_(ODMSTATUS, SetDocInfo) (THIS_
					LPSTR lpszDocId,
					WORD item,
					LPSTR lpszData ) PURE;
	STDMETHOD_(ODMSTATUS, GetDMSInfo) (THIS_
					LPSTR lpszDmsId,
					LPWORD pwVerNo,
					LPDWORD pdwExtensions ) PURE;
	STDMETHOD_(ODMSTATUS, GetLeadMoniker) (THIS_
					LPSTR lpszDocId,
					LPMONIKER FAR *ppMoniker ) PURE;

};

typedef IODMDocMan FAR * LPODMDOCMAN;

#ifdef __cplusplus
extern "C" {
#endif

// ODMA prototypes
HRESULT FAR PASCAL ODMQueryInterface( ODMHANDLE odmHandle, LPSTR lpszDocId,
	REFIID riid, LPVOID FAR *ppvObj );
ODMSTATUS FAR PASCAL ODMGetLeadMoniker( ODMHANDLE odmHandle, LPSTR lpszDocId,
	LPMONIKER FAR *ppMoniker );

// Prototype for ODMA provider entry point function
HRESULT FAR PASCAL _export ODMGetODMInterface( REFIID riid, LPVOID FAR *ppvObj,
	LPUNKNOWN pUnkOuter, LPVOID pReserved, LPSTR lpszAppId, DWORD dwEnvData );

#ifdef __cplusplus
}
#endif

#endif



